//打点事件
$(function () {

	$("#markPullImg").click(function () {
		//图标改变
		if ($("#markPullImg img").attr("src") == "image/pull_up.png") {
			$("#markPullImg img").attr("src", "image/pull_down.png");
			//显示打点文本提示列表
			$("#markList").hide();
			$("#markInput").focus();
			$("#markInput").removeClass("active");
		} else {
			$("#markPullImg img").attr("src", "image/pull_up.png");
			$("#markList").show();
			$("#markInput").addClass("active");
		}
	}).mouseover(function () {
		this.style.cursor = 'pointer';
	});
	// $("#markList li").mouseover(function(){
	// 	$(this).addClass("active");
	// }).mouseleave(function(){
	// 	$(this).removeClass("active");
	// });
})


// 点击显示列表
function showAllList() {
	//console.log(g_getAll_videfile_list);
	g_getAll_videfile_list = CRVideo_GetAllRecordFiles();
	getAllVideoList(g_getAll_videfile_list);
	$(".full_page").css("display", "block");
	$(".list_container").css("display", "block");
	//$(".detail_right_video").css('display','none');
	videoContainerHide();
}

function getAllVideoList(list) {
	//$("#table_list_container").remove(".list_all_items")
	$(".list_all_items").remove();
	if (list && list != "" && list != null) {
		var listLength = list.length;
		var str = "",
			str1 = "";
		for (var i = 0; i < listLength; i++) {
			var listState = "";
			var listName = list[i].fileName;
			var duration = parseInt(list[i].duration / 1000);
			if (/\.srt$/.test(listName)) {
				var actStr3 = "<span class=\"table_up_del_rec\" onclick=\"markFileMgr(" + i + ")\">打点管理</span>";
			} else {
				var actStr3 = "<span class=\"table_up_del_rec\" onclick=\"playbackList(" + i + ")\">回放</span>";
			}
			if (list[i].state == 0) {
				listState = "未上传";
				//str1 = "<span class=\"table_up_del_rec\" onclick=\"uploadFile("+ i +")\">上传</span>"
			} else if (list[i].state == 1) {
				listState = "上传中";
				//str1 = "";
			} else if (list[i].state == 2) {
				listState = "已上传";
				//str1 = "";
			}
			var fileSize = decimal((parseInt(list[i].size) / 1024 / 1024), 1);
			if (parseInt(fileSize) > 0) {
				fileSize = decimal((parseInt(list[i].size) / 1024 / 1024), 1) + "M";
			} else {
				fileSize = decimal((parseInt(list[i].size) / 1024), 1) + "K";
			}
			str += "<tr id=\"list_item" + i + "\" class=\"list_all_items\">" +
				"<td width=\"25%\"><div class=\"text_left\" id=\"fileName" + i + "\">" + listName + "</div></td>" +
				"<td width='11%'><div class=\"list_item_size\">" + fileSize + "</div></td>" +
				"<td width=\"14%\"><div class=\"list_item_state\">" + duration + "秒</div></td>" +
				"<td width=\"10%\"><div class=\"list_item_state\">" + listState + "</div></td>" +
				"<td width=\"40%\">" +
				"<div class=\"table_done text_left\">"
				//+ str1
				+
				"<span class=\"table_up_del_rec\" onclick=\"uploadFile(" + i + ")\">上传</span>" +
				"<span class=\"table_up_del_rec\" onclick=\"deleteFile(" + i + ")\">本地删除</span>" +
				actStr3
				//+ "<div class='table_up_perc'></div>"
				+
				"</div>" +
				"</td>" +
				"</tr>"
		}
		str += "<div style='height:0;clear:both;'></div>"
		$("#table_list_container").append(str);

	}

}

function closelistPage() {
	$(".full_page").css({
		"display": "none"
	});
	$(".list_container").css({
		"display": "none"
	});
	if (g_uploading == false) {

		//$(".detail_right_video").css('display','block');
		videoContainerShow();
		updateVideo();
	}
}
// 换为单摄像头
function changeSingle() {
	if (g_single_video)
		return
	g_single_video = true;
	if (g_layout == 'layoutA') {
		layoutA();
	} else if (g_layout == 'layoutB') {
		layoutB();
	}

	updateVideo();
}

// 换为双摄像头
function changeDouble() {
	if (!g_single_video)
		return
	g_single_video = false
	if (g_layout == 'layoutA')
		layoutA();
	else if (g_layout == 'layoutB')
		layoutB();
	updateVideo();
}

function decimal(num, v) {
	var vv = Math.pow(10, v);
	return Math.round(num * vv) / vv;
}
var videoOperateBtn = "关闭";
var micOperateBtn = "关闭";

function setVideoAndMedia() {
	$("input[name='meet_yx'][value=" + g_video_qp + "]").prop("checked", true);
	$("#size_select").val(g_video_size_type)
	$("#frame_input").val(g_video_fps)

	var audioCfg = CRVideo_GetAudioCfg();
	var micArr = CRVideo_GetAudioMicNames();
	var micArrOptionsStr = "";
	if (g_first_set_video_and_med) {
		for (var i = 0; i < micArr.length; i++) {
			if (audioCfg.micName == micArr[i]) {
				micArrOptionsStr += "<option value=\"" + micArr[i] + "\" selected=\"true\">" + micArr[i] + "</option>"
			} else {
				micArrOptionsStr += "<option value=\"" + micArr[i] + "\" >" + micArr[i] + "</option>"
			}
		}
		micArrOptionsStr = "<option value=\"\" >默认设备</option>" + micArrOptionsStr
		$(micArrOptionsStr).appendTo("#mic_select");
	}

	var spkerArr = CRVideo_GetAudioSpkNames();
	var spkerArrOptionsStr = "";
	if (g_first_set_video_and_med) {
		for (var i = 0; i < spkerArr.length; i++) {
			if (audioCfg.speakerName == spkerArr[i]) {
				spkerArrOptionsStr += "<option value=\"" + spkerArr[i] + "\" selected=\"true\">" + spkerArr[i] + "</option>"
			} else {
				spkerArrOptionsStr += "<option value=\"" + spkerArr[i] + "\" >" + spkerArr[i] + "</option>"
			}
		}
		spkerArrOptionsStr = "<option value=\"\" >默认设备</option>" + spkerArrOptionsStr
		$(spkerArrOptionsStr).appendTo("#spker_select")
	}
	var videoID = CRVideo_GetDefaultVideo(g_userID)
	var videoList = CRVideo_GetAllVideoInfo(g_userID);
	var videoListOptionsStr = "";
	if (g_first_set_video_and_med) {
		for (var i = 0; i < videoList.length; i++) {
			var item = videoList[i];
			if (videoID == item.videoID) {
				videoListOptionsStr += "<option value=\"" + item.videoID + "\" selected=\"true\">" + item.videoName + "</option>"
			} else {
				videoListOptionsStr += "<option value=\"" + item.videoID + "\" >" + item.videoName + "</option>"
			}
		}
		videoListOptionsStr = "<option value=\"-1\" >默认设备</option>" + videoListOptionsStr
		$(videoListOptionsStr).appendTo("#video_select")
	}
	$("#video_operate_btn").click(function () {
		var vStatus = CRVideo_GetVideoStatus(g_userID);
		if (vStatus == 0) {
			this.popup("没有可打开的视频设备")

		} else if (vStatus == 2) {
			CRVideo_OpenVideo(g_userID);
			$("#video_operate_btn").text("关闭");
			videoOperateBtn = "关闭";
		} else {
			CRVideo_CloseVideo(g_userID);
			$("#video_operate_btn").text("打开");
			videoOperateBtn = "打开";

		}
	})

	$("#mic_operate_btn").click(function () {
		var aStatus = CRVideo_GetAudioStatus(g_userID);
		if (aStatus == 0) {
			this.popup("没有可打开的音频设备")


		} else if (aStatus == 2) {
			CRVideo_OpenMic(g_userID);
			$("#mic_operate_btn").text("关闭");
			micOperateBtn = "关闭";
		} else {
			CRVideo_CloseMic(g_userID);
			$("#mic_operate_btn").text("打开");
			micOperateBtn = "打开";

		}
	})
	$("#video_select").change(function () {
		CRVideo_SetDefaultVideo(g_userID, $("#video_select").val());
	});
	$("#spker_select").change(function () {
		var cfg = {};
		cfg.micName = $("#mic_select").val();
		cfg.speakerName = $("#spker_select").val();
		cfg.privAgc = 0;
		cfg.privEC = 0;
		CRVideo_SetAudioCfg(cfg);
	});
	$("#mic_select").change(function () {
		var cfg = {};
		cfg.micName = $("#mic_select").val();
		cfg.speakerName = $("#spker_select").val();
		cfg.privAgc = 0;
		cfg.privEC = 0;
		CRVideo_SetAudioCfg(cfg);
	});
	g_first_set_video_and_med = false;
}
//  如果是有媒体存在时，展示三个元素 layoutA时没有媒体 g_single_video只有一个摄像头
function mediaBlockHide() {
	if (g_single_video) {
		g_mediaObj.width(1);
		g_mediaObj.height(1);
		g_videoAObj.width(1);
		g_videoAObj.height(1);
	} else {
		g_mediaObj.width(1);
		g_mediaObj.height(1);
		g_videoAObj.width(1);
		g_videoAObj.height(1);
		g_videoBObj.width(1);
		g_videoBObj.height(1);
	}
	$("#mediaContainer").hide();
}
// 如果是有媒体存在需要隐藏对应的三个元素
//当变化布局时就需要重新变化即可
function recordObjHide() {
	g_mediaObj.width(1);
	g_mediaObj.height(1);
	$("#mediaContainer").hide();
}
//当视频页面隐藏的时候
function videoContainerHide() {
	if (g_layout == "layoutA") {
		g_videoAObj.width(1);
		g_videoAObj.height(1);
		g_videoBObj.width(1);
		g_videoBObj.height(1);
		g_mediaObj.width(1);
		g_mediaObj.height(1);
		$("#mediaContainer").hide();
	} else if (g_layout == "layoutB") {
		mediaBlockHide();
	} else if (g_layout == "layoutC") {
		recordObjHide();
	}
}

function videoContainerShow() {
	if (g_layout == "layoutA") {
		layoutA();
		updateVideo();
	} else if (g_layout == "layoutB") {
		layoutB();
		updateVideo();
	} else if (g_layout == "layoutC") {
		layoutC();
	}
}
//显示加层
function showLodingPage() {
	$("#loading_gif").show();
	$("#full_page").show();
}
//隐藏加载层
function hideLoadingPage() {
	$("#loading_gif").hide();
	$("#full_page").hide();
}

//录制视频时打点事件
function setMarkText() {
	var markVal = $("#markInput").val();
	if (markVal == "") {

	} else {
		var videoFilePathName = g_location_dir + g_record;
		CRVideo_SetMarkText(videoFilePathName, g_curRecordDuration, markVal);

		$("#markList").hide();
		// var strLi = "<li onclick=\"clickMarkTextItem(this.innerHTML)\"  onmouseover=\"$(this).addClass(\'active\');\" onmouseleave=\"$(this).removeClass(\'active\');\">" + markVal + "</li>";
		// $("#markList").append(strLi);
		$("#markInput").val("").focus();
	}
}

function clickMarkTextItem(markVal) {
	$("#markInput").val(markVal);
	$("#markList").hide();
	$("#markPullImg img").attr("src", "image/pull_down.png");
	$("#markInput").focus();
}

var g_cur_mark_file_index = -1;

function markFileMgr(i) {
	var fileName = $("#fileName" + i).text().replace(".srt", "");
	$("#mark_table thead th").html(fileName);
	$(".mark_list_all_items").remove();
	// //降低'文件管理'弹层的层级到full_page(111)下面
	// if($("#list_container").css("display") == "block"){
	// 	$("#list_container").css({"z-index":110});
	// }
	var markList = JSON.parse(CRVideo_GetAllMarks(g_location_dir + fileName)).markTexts;
	var len = markList.length;
	var str = '';

	for (var i = 0; i < len; i++) {
		var item = markList[i];
		var text = item.text;
		var time = parseInt(item.timestamp / 1000);

		str += "<tr id=\"mark_list_item" + i + "\" class=\"mark_list_all_items\">" +
			"<td width=\"10%\"><div class=\"mark_time mark_list_item\"><span style=\"display:none;\" id=\"markTime" + i + "\">" + item.timestamp + "</span><span>" + time + "秒</span></div></td>" +
			"<td width='65%'><div class=\"mark_list_item no_wrap\" id=\"markText" + i + "\">" + text + "</div></td>" +
			"<td width=\"25%\">" +
			"<div class=\"table_done mark_list_item\">"
			//+ str1
			+
			"<span class=\"table_act\" onclick=\"changeMarkTextOp(" + i + ")\">修改</span>" +
			"<span class=\"table_act\" onclick=\"deleteMarkText(" + i + ")\">删除</span>"

			//+ "<div class='table_up_perc'></div>"
			+
			"</div>" +
			"</td>" +
			"</tr>"
	}
	$("#mark_table").append(str);
	//显示管理弹层
	// $("#mark_list_container_wrapper")
	$("#mark_list_container_wrapper").show();
	$("#mark_list_container").show();

	//
}
//弹出修改打点信息层
function changeMarkTextOp(i) {
	g_cur_mark_file_index = i; //记录修改该文件下的第几个打点信息
	$("#MarkChangeInput").val("");
	$("#mark_change_container_wrapper").show();
	$("#mark_change_container").show();

}

function deleteMarkText(i) {
	if ($("#mark_list_item" + i).length > 0) {
		//界面移除和视频文件上移除
		var ms = $("#markTime" + i).html();
		$("#mark_list_item" + i).remove();
		CRVideo_RemoveMarkText(g_location_dir + $("#mark_table thead th").html(), ms);
		//console.log("mark-shipin file: "+g_location_dir+$("#mark_table thead th").html());

	}

}

function closeMarkListPage() {
	$("#mark_list_container_wrapper").hide();
	$("#mark_list_container").hide();
	//222
	// if($("#list_container").css("display") == "block"){
	// 	$("#list_container").css({"z-index":222});
	// }
}

function closeMarkChangePage() {
	$("#mark_change_container_wrapper").hide();
	$("#mark_change_container").hide();
}
//修改打点信息层，点击 OK
function changeMarkText() {

	var txt = $("#MarkChangeInput").val();
	if (txt != "" && g_cur_mark_file_index != -1) {
		//
		var fileName = $("#mark_table thead th").html();
		var ms = $("#markTime" + g_cur_mark_file_index).html();
		CRVideo_SetMarkText(g_location_dir + fileName, ms, txt);
		//
		$("#markText" + g_cur_mark_file_index).html(txt);
		$("#mark_change_container_wrapper").hide();
		$("#mark_change_container").hide();

	}
}

//判断浏览器版本号是否ie9-
function browerversion() {
	var ua = navigator.userAgent,
		ver = 0,
		versiondata,
		versionbool;

		if(ua){
			if(ua.match(/MSIE\s+([\d]+)\./i)){
				ver = RegExp.$1;
			}else if(ua.match(/Trident.*rv\s*:\s*([\d]+)\./i)){
				ver = RegExp.$1;
			}
		}

		versiondata = parseInt(ver);

		if(versiondata <= 9 && versiondata != 0){
			versionbool = true;
		}else{
			versionbool = false;
		}
	
		// versionbool    true: 低于ie9   false: ie10+
		return versionbool;
}

//检查并停止录制，影音功能（掉线或者离线时，需要使用）
function stopMediaAndRecord() { 
	if(g_startRecord){
		CRVideo_DestroyLocMixer(g_curMixerID);
		g_startRecord = false;
		$("#startRecordCon").css("display", "block");
		$("#stopRecordCon").css("display", "none");

		//修改下一次录制时，混图器ID
		g_curMixerID = "webM-" + g_mxierNum++;
	}

	if (g_playbacking) { //如果是正在回放
		//CRVideo_StopPlayMedia(); // 如果正在回放时点击回放则停止播放
		g_playbacking = false;
		$('#playbackBtn').text("回放");
	}

	if (g_nowTime_play_num != -1 || g_layout == 'layoutB') { //正在播放影音文件，则切换影音文件
		//CRVideo_StopPlayMedia();
		
		$("#videoList" + g_nowTime_play_num + " " + ".voice1_item_play").css("display", "block")
		$("#videoList" + g_nowTime_play_num + " " + ".voice1_item_stop").css('display', 'none');
		$("#videoList" + g_nowTime_play_num + " " + ".voice1_item_pause").css('display', 'none')

		g_nowTime_play_num = -1;
	}
 }